//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace Bwg.Audio.Acm
{
    public class AcmFourCC
    {
        public byte[] FourCC;

        public AcmFourCC(byte[] data)
        {
            Debug.Assert(data.GetLength(0) == 4);

            FourCC = new byte[4];
            Array.Copy(data, FourCC, 4);
        }

        public override string ToString()
        {
            string str = string.Empty;

            for (int i = 0; i < 4; i++)
            {
                byte b = FourCC[i];
                if (b == 0)
                    str += '-';
                else
                    str += (char)FourCC[i];
            }

            return str;
        }

        public AcmFourCC(byte b1, byte b2, byte b3, byte b4)
        {
            FourCC = new byte[4];
            FourCC[0] = b1;
            FourCC[1] = b2;
            FourCC[2] = b3;
            FourCC[3] = b4;
        }
    }
}
