//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Burner
{
    /// <summary>
    /// This class has the information about the text associated with a progress messages
    /// </summary>
    public class ProgressText
    {
        /// <summary>
        /// The long name of the current operation (e.g. Writing Track 'abcdef')
        /// </summary>
        public readonly string LongName ;

        /// <summary>
        /// The short name of the current operation (e.g. Writing)
        /// </summary>
        public readonly string ShortName ;

        /// <summary>
        /// Constructor for the progress text object
        /// </summary>
        /// <param name="longname">the long name</param>
        /// <param name="shortname">the short name</param>
        public ProgressText(string longname, string shortname)
        {
            LongName = longname;
            ShortName = shortname;
        }
    }
}
