//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;
using Bwg.Logging ;
using Bwg.Scsi ;
using Bwg.Burner ;

namespace Bwg.Burner
{
    /// <summary>
    /// This class represnts a sessions on a disk
    /// </summary>
    public class Session
    {
        /// <summary>
        /// This is the collection of tracks on the sessions
        /// </summary>
        public Track[] Tracks;

        /// <summary>
        /// The session number for this session
        /// </summary>
        public int Number;

        /// <summary>
        /// Creates a new session object
        /// </summary>
        public Session(int num)
        {
            Number = num;
            Tracks = null ;
        }

        /// <summary>
        /// Add a track to the session
        /// </summary>
        /// <param name="t">the track to add</param>
        public void AddTrack(Track t)
        {
            if (Tracks == null)
                Tracks = new Track[1] ;
            else
            {
                Array.Resize(ref Tracks, Tracks.GetLength(0) + 1) ;
            }

            Tracks[Tracks.GetLength(0) - 1] = t ;
        }

        /// <summary>
        /// Return the length of this session in sector.  This is calculated as the total lengths of the
        /// contained tracks
        /// </summary>
        public int Length
        {
            get
            {
                int size = 0;
                foreach (Track t in Tracks)
                    size += t.Info.TrackSize;
                return size;
            }
        }
    }
}
