//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

namespace Bwg.Controls
{
    /// <summary>
    /// This class displays all EXE's and DLL's in the bin directory and
    /// the versions of each.
    /// </summary>
    public partial class ModuleVersionForm : BwgBurnBaseForm
    {
        /// <summary>
        /// Create the module form
        /// </summary>
        public ModuleVersionForm(string version)
        {
            InitializeComponent();

            string apppath = Application.ExecutablePath ;
            string appdir = Path.GetDirectoryName(apppath);
            string[] files = Directory.GetFiles(appdir, "*.exe");

            AddFiles(files);

            files = Directory.GetFiles(appdir, "*.dll");

            AddFiles(files);

            ProgramName.Text = "BwgBurn Version " + version;
        }

        private void AddFiles(string[] files)
        {
            foreach(string f in files)
                AddFile(f) ;
        }

        private void AddFile(string f)
        {
            char[] seps = new char[1] { ',' };
            try
            {
                Assembly a = Assembly.LoadFrom(f);
                string[] fields = a.FullName.Split(seps);
                ListViewItem item = new ListViewItem(fields[0]);
                if (fields[1].Length > 9)
                    item.SubItems.Add(fields[1].Substring(9));
                else
                    item.SubItems.Add(fields[1]);

                ModuleList.Items.Add(item);
            }
            catch (Exception)
            {
            }
        }

        private void License_Click(object sender, EventArgs e)
        {
            string dir = GetCopyrightFile();
            DisplayLicense form = new DisplayLicense(dir);
            form.ShowDialog();
        }

        private void ProgramName_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ProgramName.Links[ProgramName.Links.IndexOf(e.Link)].Visited = true;
            System.Diagnostics.Process.Start("http://bwgburn.sourceforge.net");
        }
    }
}