using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Bwg.Burner ;

namespace Bwg.CreateAudioDisk
{
    class CDTextDiskProps
    {
        private CDTextDataString m_title;
        private CDTextDataString m_performer;
        private CDTextDataString m_songwriter;
        private CDTextDataString m_composer;
        private CDTextDataString m_arranger;
        private CDTextDataString m_message;
        private CDTextDataGenre m_genre;

        [Description("The title of this disc")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Title
        {
            get { return m_title; }
            set { m_title = value; }
        }

        [Description("The artist that performed this disc")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Performer
        {
            get { return m_performer; }
            set { m_performer = value; }
        }

        [Description("The songwriter for this disc")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Songwriter
        {
            get { return m_songwriter; }
            set { m_songwriter = value; }
        }

        [Description("The composer for this disc")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Composer
        {
            get { return m_composer; }
            set { m_composer = value; }
        }

        [Description("The arranger for this disc")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Arranger
        {
            get { return m_arranger; }
            set { m_arranger = value; }
        }

        [Description("A message associated with this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Message
        {
            get { return m_message; }
            set { m_message = value; }
        }

        [Description("The genre for this disk")]
        [TypeConverter(typeof(CDTextDataGenreConverter))]
        public CDTextDataGenre Genre
        {
            get { return m_genre; }
            set { m_genre = value; }
        }

        public CDTextDiskProps()
        {
            m_arranger = new CDTextDataString();
            m_composer = new CDTextDataString();
            m_message = new CDTextDataString();
            m_performer = new CDTextDataString();
            m_songwriter = new CDTextDataString();
            m_title = new CDTextDataString();
        }
    }
}
