//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Bwg.Burner;
using Bwg.Isofs;
using Bwg.Scsi;

namespace Bwg.CreateDataDisk
{
    class ImageGeneratorSource : DataSource
    {
        private int m_sector_count;
        private DiskImageCreator m_creator;


        public ImageGeneratorSource(DiskImageCreator c)
        {
            m_creator = c;
            long size = m_creator.SizeInBlocks;

            Debug.Assert(size <= Int32.MaxValue);
            m_sector_count = (int)size;
        }

        public override string Name
        {
            get
            {
                return "ISO Image Creator";
            }
        }

        public override long SectorCount
        {
            get
            {
                return m_sector_count;
            }
        }

        public override long SendData(WriteBufferPool pool, long start_sector, int sector_size, long lba)
        {
            WriteBufferStream stream = new WriteBufferStream(pool, sector_size, lba);
            m_creator.CreateImage(stream, start_sector);
            stream.Flush();
            return m_sector_count;
        }
    }
}
