//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Bwg.CreateDataDisk
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string [] args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            CreateDataDiskForm form = new CreateDataDiskForm();

            string projfile = string.Empty;
            int i = 0;
            while (i < args.GetLength(0))
            {
                string arg = args[i++];
                if (arg == "-ext")
                {
                    if (i == args.GetLength(0) - 1)
                    {
                        MessageBox.Show("Illegal command line arguments, -ext expects an extension", "Error!");
                        return;
                    }

                    form.AddExtension(args[i++]);
                }
                else if (arg == "-hide-image-settings")
                {
                    form.HideImageSettings = true;
                }
                else if (arg == "-title")
                {
                    if (i == args.GetLength(0) - 1)
                    {
                        MessageBox.Show("Illegal command line arguments, -title expects a string", "Error!");
                        return;
                    }
                    form.Text = args[i++];
                }
                else if (arg[0] != '-')
                {
                    form.InitialProject = arg;
                }
            }

            form.ReInitialize();
            Application.Run(form);
        }
    }
}