//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Database.Freedb
{
    public class FreeDBResponseArgs : EventArgs
    {
        #region public types
        public enum ResponseType
        {
            Success,
            UnknownError,
            CouldNotContactServer,
            LoginFailed,
            InvalidServerResponse
        }
        #endregion

        #region public properties
        /// <summary>
        /// The status of the request.
        /// </summary>
        public ResponseType Status;

        /// <summary>
        /// The result (if the status is Success)
        /// </summary>
        public FreeDBRequest Result;

        #endregion

        /// <summary>
        /// Create the response args
        /// </summary>
        /// <param name="t">The type of response</param>
        /// <param name="result">The specific result, if the query sucessed</param>
        public FreeDBResponseArgs(ResponseType t, FreeDBRequest result)
        {
            Status = t;
            Result = result;
        }
    }
}
