//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Net;

namespace Bwg.Database.Freedb
{
    public class FreeDBUserInfo
    {
        /// <summary>
        /// The name of the user
        /// </summary>
        public readonly string UserName;

        /// <summary>
        /// The name of the user's host
        /// </summary>
        public readonly string UserHost;

        /// <summary>
        /// The name of the client application
        /// </summary>
        public readonly string Client;

        /// <summary>
        /// The version number for the client application
        /// </summary>
        public readonly string ClientVersion;

        public FreeDBUserInfo(string user, string host, string client, string version)
        {
            UserName = user;
            UserHost = host;
            Client = client;
            ClientVersion = version;
        }

        public FreeDBUserInfo(string client, string version)
        {
            UserName = System.Environment.UserName;
            UserHost = Dns.GetHostName();
            Client = client;
            ClientVersion = version;
        }

    }
}
