using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Bwg.Controls;
using Bwg.Burner;
using Bwg.Scsi;

namespace Bwg.DiskView
{
    public partial class DiskView : BwgBurnBaseForm
    {
        public DiskView()
        {
            InitializeComponent();

            DriveSelector.Logger = m_logger;
            DriveSelector.InitializeDeviceList(false);
        }

        private void driveSelectDropDown1_SelectedIndexChanged(object sender, EventArgs e)
        {
            ReadLeadin();
        }

        private void ReadLeadin()
        {
            Device dev;
            Drive drive = null;

            string dname = (string)DriveSelector.SelectedItem;
            dev = new Device(m_logger);
            if (!dev.Open(dname[0]))
            {
                MessageBox.Show("Cannot open device '" + dname + "'", "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            drive = new Drive(dev);
            DiskOperationError status = drive.Initialize();
            if (status != null)
            {
                drive.Dispose();
                MessageBox.Show("Cannot initialize drive '" + dname + "' - " + status.Message, "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return ;
            }

            ReadLeadin(drive);

            drive.Dispose();
        }
       
        private void ReadLeadin(Drive drive)
        {
        }
    }
}