using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    /// <summary>
    /// This class represents a disk that is being mastered
    /// </summary>
    public class DvdDisc
    {
        #region private member variables
        /// <summary>
        /// The main video title set that results in the VIDEO_TS.IFO and
        /// VIDEO_TS.BUP file.
        /// </summary>
        // private DvdVideoTitleSet m_main_title_set;

        /// <summary>
        /// The list of other video title sets on the disc
        /// </summary>
        private IList<DvdVideoTitleSet> m_video_title_sets;

        /// <summary>
        /// The VMGM_MAT object for the disc
        /// </summary>
        private VMGM_MAT m_vmgm_mat;

        /// <summary>
        /// The VMG_PTT_SRPT object for the disc
        /// </summary>
        private VMG_PTT_SRPT m_vmg_ptt_srpt;

        /// <summary>
        /// The VMGM_PGCI_UT object for the disc
        /// </summary>
        private VMGM_PGCI_UT m_vmgm_pgci_ut;
        #endregion

        #region public constructors
        public DvdDisc()
        {
            // m_main_title_set = null;
            m_video_title_sets = new List<DvdVideoTitleSet>();
        }
        #endregion

        #region public properties
        public VMGM_MAT VideoManagerInformationManagement
        {
            get { return m_vmgm_mat; }
            set { m_vmgm_mat = value; }
        }

        public VMG_PTT_SRPT VideoManagerPartOfTitleSearch
        {
            get { return m_vmg_ptt_srpt; }
            set { m_vmg_ptt_srpt = value; }
        }

        public VMGM_PGCI_UT VideoManagerProgramChainUnits
        {
            get { return m_vmgm_pgci_ut; }
            set { m_vmgm_pgci_ut = value; }
        }
        #endregion
    }
}
