using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Bwg.DvdMaster
{
    public class VMG_PTT_SRPT : DvdDataStructure
    {
        #region private member variables
        private ushort m_number_of_titles;
        private uint m_address_of_last_byte;
        private VMG_PTT_SRPT_Title_Desc[] m_title_descs;
        #endregion

        #region constructor
        public VMG_PTT_SRPT()
        {
        }

        public VMG_PTT_SRPT(byte[] data)
        {
            int offset = 0;

            m_number_of_titles = ExtractUInt2(data, ref offset);

            // Padding of 2 bytes
            offset += 2;

            m_address_of_last_byte = ExtractUInt4(data, ref offset);

            m_title_descs = new VMG_PTT_SRPT_Title_Desc[m_number_of_titles];
            for (int i = 0; i < m_number_of_titles; i++)
            {
                VMG_PTT_SRPT_Title_Desc desc = new VMG_PTT_SRPT_Title_Desc(data, ref offset);
                m_title_descs[i] = desc;
            }
        }
        #endregion

        #region public properties
        [Description("Number Of Titles in the part of title search list")]
        public ushort NumberOfTitles
        {
            get { return m_number_of_titles; }
        }

        [Description("Address of the last byte of this structure")]
        public uint AddressOfLastByte
        {
            get { return m_address_of_last_byte; }
        }

        public VMG_PTT_SRPT_Title_Desc this[int index]
        {
            get { return m_title_descs[index]; }
        }
        #endregion
    }
}
