using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Hardware
{
    public class HardwareDevice
    {
        #region private member variables
        private string m_name;
        private string m_desc;
        private string m_class;
        private string m_class_guid;
        private string m_key_name ;
        private string[] m_hardware;
        #endregion

        #region constructor
        public HardwareDevice(string key)
        {
            m_key_name = key;
            m_name = string.Empty ;
            m_desc = string.Empty ;

            m_hardware = new string[0];
        }
        #endregion

        #region public methods
        public void AddHardware(string str)
        {
            int count = m_hardware.GetLength(0);
            Array.Resize(ref m_hardware, count + 1);
            m_hardware[count] = str;
        }
        #endregion

        #region properties
        public string Name
        {
            get
            {
                if (m_name != string.Empty)
                    return m_name;

                if (m_desc != string.Empty)
                    return m_desc;

                return m_key_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_desc;
            }
            set
            {
                m_desc = value;
            }
        }

        public string Class
        {
            get
            {
                return m_class;
            }
            set
            {
                m_class = value;
            }
        }

        public string ClassGUID
        {
            get
            {
                return m_class_guid;
            }
            set
            {
                m_class_guid = value;
            }
        }

        public string[] Hardware
        {
            get
            {
                return m_hardware;
            }
        }

        public bool IsIde
        {
            get
            {
                return HardwareStartsWith("IDE");
            }
        }

        public bool IsUsb
        {
            get
            {
                return HardwareStartsWith("USB") ;
            }
        }

        public bool IsFirewire
        {
            get
            {
                return HardwareStartsWith("SBP2");
            }
        }

        public bool IsScsi
        {
            get
            {
                return HardwareStartsWith("SCSI");
            }
        }
        #endregion

        #region private methods
        public bool HardwareStartsWith(string begin)
        {
            foreach (string str in m_hardware)
            {
                if (str.StartsWith(begin))
                    return true;
            }
            return false;
        }
        #endregion
    }
}
