//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace Bwg.Isofs
{
    class ElToritoBootVolumeTask : CreatorTask
    {
        public ElToritoBootCatalogTask CatalogTask;

        public ElToritoBootVolumeTask()
        {
            CatalogTask = null;
        }

        public override bool UpdateLayout(DiskImageCreator creator, DiskInfo info)
        {
            // Reserve one block for the boot area
            info.CurrentBlock++;
            return true ;
        }

        public override bool Write(DiskImageCreator creator, DiskInfo info, IsoWriteStream strm)
        {
            long pos = strm.Position ;
            string id = "EL TORITO SPECIFICATION";

            strm.WriteUint8(0);                     // Volume descriptor type (0 = boot record)
            strm.WriteString("CD001");              // Required ID string
            strm.WriteUint8(1);                     // Version of this boot record (1)
            strm.WriteString(Encoding.ASCII, id, 32, (char)0);            // Required name for EL TORITO
            strm.WriteZeros(32);                    // Unused, must be zero

            // Get the boot catalog
            Debug.Assert(CatalogTask != null);
            strm.WriteUint32Small((uint)CatalogTask.BlockAddress);
            strm.WriteZeros(1973);

            // Set should have written exactly on page
            Debug.Assert(strm.Position - pos == 2048);

            return true;
        }
    }
}
