//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    /// <summary>
    /// This class represnts an extent on a disk (or disk image)
    /// </summary>
    [Serializable()]
    public class ExtentAd
    {
        /// <summary>
        /// The length of the extent in bytes
        /// </summary>
        public long Bytes;

        /// <summary>
        /// The location of the extent
        /// </summary>
        public long Location;

        /// <summary>
        /// An empty extent
        /// </summary>
        static public ExtentAd Empty = new ExtentAd(0, 0) ;

        /// <summary>
        /// Create a new extent given its location and length
        /// </summary>
        /// <param name="location">the location</param>
        /// <param name="length">the length</param>
        public ExtentAd(long location, long length)
        {
            Bytes = length;
            Location = location;
        }

        /// <summary>
        /// The length of the extent in sector
        /// </summary>
        public long Sectors
        {
            get
            {
                long ret = Bytes / 2048;
                if ((Bytes % 2048) != 0)
                    ret++;

                return ret;
            }
        }
    }
}
