//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    class ParsedElementEvent : EventArgs
    {
        /// <summary>
        /// The element parsed from the file
        /// </summary>
        public readonly string AddLine;

        /// <summary>
        /// This is the name of the content file where this entry came from
        /// </summary>
        public readonly string ContentFileName;

        /// <summary>
        /// This is the line number in the content file where this entry was
        /// parsed.
        /// </summary>
        public readonly uint LineNumber;

        public ParsedElementEvent(string elem, string filename, uint lineno)
        {
            AddLine = elem;
            ContentFileName = filename;
            LineNumber = lineno;
        }
    }
}
