//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    class TaskRepeater : CreatorTask
    {
        private CreatorTask m_task;
        private int m_count;

        public TaskRepeater(CreatorTask task, int count)
        {
            m_task = task;
            m_count = count;
        }

        public override bool UpdateLayout(DiskImageCreator creator, DiskInfo info)
        {
            //
            // This call will update the info.CurrentBlock to reflect the blocks
            // needed by the task
            //
            long start = info.CurrentBlock;
            if (!m_task.UpdateLayout(creator, info))
                return false;

            m_task.BlockSize = info.CurrentBlock - start;

            // Ok, the above should have set the size and the location of the task
            // now take into account the other instances
            info.CurrentBlock += (m_task.BlockSize * (m_count - 1));

            return true;
        }

        public override bool Write(DiskImageCreator creator, DiskInfo info, IsoWriteStream strm)
        {
            long addr = BlockAddress ;
            for (int i = 0; i < m_count; i++)
            {
                m_task.BlockAddress = addr ;
                if (!m_task.Write(creator, info, strm))
                    return false;

                addr += m_task.BlockSize;
            }

            return true;
        }
    }
}
